%% Intro to Matlob Topics to cover Day 3

% Getting setup for remainder of the semester with data and EEGLab toolbox
% Download Sample Data and place in a directory that is easy to access
% Download EEGLab and unzip into a directory of your choosing (but remember where!)
% Create Shortcut to run EEGLab from shortcut bar in Matlab



%% Indexing and logicals
% ==
% ~=
% > >=
% < <=
% |
% &

M1 = rand(1,100); M1 = 100*(M1 - mean(M1));  % What does this do?  
                                             % What is the range likely to be?
% find all entries greater than 10
% Find entries equal to 10
% Find all entries greater than 5 and less than 10

%% Exercise 3
edit Exercise3.m

%% Looping
% for
% end
% Make a loop for 5 iterations to display the iteration number
% if
%    else
%    elseif
% switch
%    case
%    otherwise
% while
% tic
% toc
% vectorizing (in Excercise 4)
% 
%% Exercise 4
edit Exercise4.m

% see also forloop.m

%% Scripts versus Functions
% scripts just contain code, and can be run from the command line.
% any variables they create are available in the global workspace
clear all;
FunPlot;
% 
% anything that is used in function does not return to the main program,
% unless you pass it back out.  
% Just like in Vegas ...What happens in the function, stays in the
% function...
clear all;
answer = sample_func(99)

% Look at variables in your workspace
% Open Sample_func to look at other variables that never made it out

% Your goal -- write functions to accomplish tasks, and then write a much
% shorter script that calls functions.  This is helpful for several
% reasons:
%  1) Makes deciphering code much easier
%  2) Makes altering code much easier
%  3) Makes porting code to new projects much easier
%  4) Makes sharing code much easier
%  5) Keeps your workspace free of extraneous variables, which:
%    a) Makes it tidier and easier to keep track of things
%    b) Keeps memory use lower
%    c) Avoids inadvertent conflict of variables with same names

% Functions are great, but modules can also be helpful
% Your big unwieldy script can be broken down into smaller modules (scripts)
% (modules)
edit longversion.m
edit shortversion.m

% Exercise 5 -- write a function
edit Exercise5.m


%% Plotting
% figure
% plot  -- plot(y)  or plot(x,y)
% subplot
% plot3 -- plot(x,y,z) 
%   e.g. t = 0:pi/50:10*pi;
%        plot3(sin(t),cos(t),t)
% scatter
% hist
% fill %e.g.,  fill([1,1,100,100],[1,100,100,1],'r')
% imagesc
    time_vec = [0.001:0.001:1];  % 1000 time points for 1 second
    power_vec = logspace(0,1.477,10); % 10 steps from 1 to 30 hz (log 30 is 1.477)
    % Make sine waves of each freq at 100 Hz
    C = [make_sin(power_vec(1),100); ...
         make_sin(power_vec(2),100); ...
         make_sin(power_vec(3),100); ...
         make_sin(power_vec(4),100); ...
         make_sin(power_vec(5),100); ...
         make_sin(power_vec(6),100); ...
         make_sin(power_vec(7),100); ...
         make_sin(power_vec(8),100); ...
         make_sin(power_vec(9),100); ...
         make_sin(power_vec(10),100); ...
         ];
    imagesc(time_vec,power_vec,C)
    set(gca,'Ydir','normal')
% xlabel
% ylabel
% title

% Use doc to learn about colors, linestyles
%
% be sure to also look at mesh, and surface, and ellipsoid
EllipsoidMan
PlayingFrisbee

% Excercise 6 -- plotting
% on your own if you want more practice
edit Exercise6.m

%% Strings and other comparisons
% sprintf -- string print format, returns string
% strcmp, strcmpi -- compares 2 strings, output logical
% strfind - finds starting position of a string within another
% regexp regexpi -- returns position of matched expression -- output linear index
% ismember ~ismember -- returns linear index/indices
% all may be useful for parsing text output from experimental programs


%% File importing and exporting
% readmatrix (reads csv and delimited data; legacy versions csvread, dlmread)
% load (loads mat files)
% save (saves variables, default format as MAT file)
% writematrix (writes delimited data; legacy versions csvwrite, dlmwrite)
% xlsread
% xlswrite
% fprintf (use with fopen, useful for a log file)

%% EEG Lab stuff  
% EEGLab environment
% Importing data
% EEGLab GUI and command history
% plotting and more plotting

%% Preprocessing
edit EEG_Preprocess




